import { Input, Injectable, ViewChild } from '@angular/core';
import Prism from 'prismjs';
import * as _ from 'lodash-es';
export class PrismClass {
    constructor() {
        this.changed = false;
        this.async = false;
        this.callback = undefined;
        this.interpolation = false;
    }
    set code(value) {
        this._code = value;
    }
    get code() {
        return this._code;
    }
    highlight(changed = false) {
        if (this.changed === changed) {
            if (this.codeElementRef) {
                if (this.code) {
                    this.highlightCode();
                }
                else {
                    this.highlightElement();
                }
                this.changed = false;
            }
        }
    }
    highlightCode() {
        if (typeof (this.code) === 'string' && typeof (this.language) === 'string') {
            if (typeof (this.interpolation) === 'boolean' && this.interpolation === true) {
                this.interpolationCode();
            }
            this.codeElementRef.nativeElement.innerHTML = Prism.highlight(this.code, Prism.languages[this.language]);
        }
    }
    highlightElement() {
        Prism.highlightElement(this.codeElementRef.nativeElement, this.async, this.callback);
    }
    interpolationCode() {
        this.code = _.template(this.code, { interpolate: /{{([\s\S]+?)}}/g })(this);
    }
}
PrismClass.decorators = [
    { type: Injectable },
];
PrismClass.ctorParameters = () => [];
PrismClass.propDecorators = {
    'async': [{ type: Input, args: ['async',] },],
    'callback': [{ type: Input, args: ['callback',] },],
    'code': [{ type: Input, args: ['code',] },],
    'codeElementRef': [{ type: ViewChild, args: ['codeElementRef',] },],
    'language': [{ type: Input, args: ['language',] },],
    'interpolation': [{ type: Input, args: ['interpolation',] },],
};
//# sourceMappingURL=prism.class.js.map